package no.ntnu.stianren.applist;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Timer;
import java.util.TimerTask;
import android.app.Activity;
import android.app.ActivityManager;
import android.app.ListActivity;
import android.app.NotificationManager;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.content.pm.PermissionInfo;
import android.content.pm.PackageManager.NameNotFoundException;
import android.content.res.Resources;
import android.database.Cursor;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CheckedTextView;
import android.widget.CompoundButton;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;

public class ShowSettings extends Activity {

	private Intent i;
	@Override
	public void onCreate(Bundle savedInstanceState) {
		i = getIntent();
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		super.onCreate(savedInstanceState);
		setContentView(R.layout.settings);
		
		CheckBox cb1 = (CheckBox)findViewById(R.id.checkBox1);
		CheckBox cb2 = (CheckBox)findViewById(R.id.checkBox3);
		CheckBox cb3 = (CheckBox)findViewById(R.id.checkBox4);
		CheckBox cb4 = (CheckBox)findViewById(R.id.checkBox5);
		CheckBox cb5 = (CheckBox)findViewById(R.id.checkBox6);
		
		String fineGPSLocation = "fine (GPS) location";
		String idOfFineGPSLocation = findId(fineGPSLocation);
		Log.i("Permissions","fake_setting: " + findFakeSetting(idOfFineGPSLocation));
		
		if (findFakeSetting(idOfFineGPSLocation).matches("1")) {
			cb1.setChecked(true);
		}
		else if (findFakeSetting(idOfFineGPSLocation).matches("2")) {
			cb2.setChecked(true);
		}
		else if (findFakeSetting(idOfFineGPSLocation).matches("3")) {
			cb3.setChecked(true);
		}
		else if (findFakeSetting(idOfFineGPSLocation).matches("4")) {
			cb4.setChecked(true);
		}
		else if (findFakeSetting(idOfFineGPSLocation).matches("5")) {
			cb5.setChecked(true);
		}
		
		cb1.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
			
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				updateFakeSetting("1");
			}
		});
		cb2.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
			
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				updateFakeSetting("2");
			}
		});
		cb3.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
			
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				updateFakeSetting("3");
			}
		});
		cb4.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
			
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				updateFakeSetting("4");
			}
		});
		cb5.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
			
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				updateFakeSetting("5");
			}
		});

	}
	
	public void updateFakeSetting(String cbNum) {

	      String lol = findId("fine (GPS) location");
	      if (lol == null)
	      {
	    	  Log.i("Permissions", "Couldn't find index of query");
	      }
	      else {
	    	  Log.i("Permissions", "ID of queried string: " + lol);
	    	  ContentValues editedValues = new ContentValues();
	    	  if (cbNum.matches(findFakeSetting(lol))) {
	    		  Log.i("Permissions", "Already set!");
	    		  editedValues.put("fake", "0");
	    		  editedValues.put("fake_setting", "0");
	    		  getContentResolver().update(Uri.parse("content://no.ntnu.provider.settings/permissions/" + lol), editedValues, null, null);
	    	  }
	    	  else {
	    		  Log.i("Permissions", "Updating setting!");
		    	  editedValues.put("fake", "1");
		    	  editedValues.put("fake_setting", cbNum);
		    	  getContentResolver().update(Uri.parse("content://no.ntnu.provider.settings/permissions/" + lol), editedValues, null, null);
		    	  Log.i("Permissions", "Successfully updated fake_setting - reloading UI");
		    	  listPermissions();
	    	  }
	    	  this.finish();
	    	  Intent myIntent = new Intent(ShowSettings.this, ShowSettings.class);
	    	  ShowSettings.this.startActivity(myIntent);
	      }
	}

	public void listPermissions() {
		Uri allEntries = Uri.parse("content://no.ntnu.provider.settings/permissions");
		Cursor c2 = managedQuery(allEntries, null, null, null, null);
		if (c2.moveToFirst())
		{
			do
			{
				Log.i("Permissions", "ID: " + c2.getString(c2.getColumnIndex("_id")) + ", " + c2.getString(c2.getColumnIndex("AP")) + ", " + c2.getString(c2.getColumnIndex("fake")) + ", " + c2.getString(c2.getColumnIndex("fake_setting")));
			}
			while (c2.moveToNext());
		}
	}

	public String findId(String toFind) {
		Uri allEntries = Uri.parse("content://no.ntnu.provider.settings/permissions");
		Cursor c2 = managedQuery(allEntries, null, null, null, null);
		String s = null;
		String retur = null;
		if (c2.moveToFirst())
		{
			do
			{
				s = c2.getString(c2.getColumnIndex("AP"));
				if (s.equals(toFind))
				{
					//Log.i("Permissions", "Found it!");
					retur = c2.getString(c2.getColumnIndex("_id"));
					break;
				}
			}
			while (c2.moveToNext());
		}
		return retur;
	}
	
	public String findFakeSetting(String id)
	{
		Uri allEntries = Uri.parse("content://no.ntnu.provider.settings/settings");
		Cursor c = managedQuery(allEntries, null, null, null, null);
		String s = null;

		if (c.moveToFirst())
		{
			do
			{
				s = c.getString(c.getColumnIndex("_id"));
				if (s.equals(id))
				{
					return c.getString(c.getColumnIndex("fake_setting"));
					}
			} while (c.moveToNext());
		}
		return "0";
	}
	
}
