package com.location.finder;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.location.Address;
import android.util.Log;

public class GeoCoder {

	public static Double latitud;
	public static double longitud;
	
    public static List<Address> getFromLocation(double lat, double lon, int maxResults) {
    	
    	latitud = lat;
    	longitud = lon;
    	Log.i("feilsking", "lat + lon:" +latitud + longitud);
        String urlStr = "http://maps.google.com/maps/geo?q=" + latitud + "," + longitud + "&output=json&sensor=false";
                String response = "";
                List<Address> results = new ArrayList<Address>();
                HttpClient client = new DefaultHttpClient();
                
                Log.d("ReverseGeocode", urlStr);
                try {
                        HttpResponse hr = client.execute(new HttpGet(urlStr));
                        HttpEntity entity = hr.getEntity();

                        BufferedReader br = new BufferedReader(new InputStreamReader(entity.getContent()));

                        String buff = null;
                        while ((buff = br.readLine()) != null)
                                response += buff;
                } catch (IOException e) {
                        e.printStackTrace();
                }

                JSONArray responseArray = null;
                try {
                        JSONObject jsonObject = new JSONObject(response);
                        responseArray = jsonObject.getJSONArray("Placemark");
                } catch (JSONException e) {
                        return results;
                }

                Log.d("ReverseGeocode", "" + responseArray.length() + " result(s)");
                
                for(int i = 0; i < responseArray.length() && i < maxResults-1; i++) {
                	Locale locale2 = new Locale("en"); 
                	Locale.setDefault(locale2);
                	Address addr = new Address(Locale.getDefault());

                        try {
                                JSONObject jsl = responseArray.getJSONObject(i);

                                String addressLine = jsl.getString("address");

                                if(addressLine.contains(","))
                                        addressLine = addressLine.split(",")[0];

                                addr.setAddressLine(0, addressLine);

                                jsl = jsl.getJSONObject("AddressDetails").getJSONObject("Country");
                                addr.setCountryName(jsl.getString("CountryName"));
                                addr.setCountryCode(jsl.getString("CountryNameCode"));
                                results.add(addr);
                                jsl = jsl.getJSONObject("AdministrativeArea");
                                addr.setAdminArea(jsl.getString("AdministrativeAreaName"));
                                results.add(addr);
                                 jsl = jsl.getJSONObject("SubAdministrativeArea");
                                 addr.setSubAdminArea(jsl.getString("SubAdministrativeAreaName"));
                                 results.add(addr);
                                 jsl = jsl.getJSONObject("Locality");
                                 addr.setLocality(jsl.getString("LocalityName"));
                                 addr.setThoroughfare(jsl.getJSONObject("Thoroughfare").getString("ThoroughfareName"));
                               
                                

                                 //addr.setPostalCode(jsl.getJSONObject("PostalCode").getString("PostalCodeNumber"));
                                

                        } catch (JSONException e) {
                                e.printStackTrace();
                                continue;
                        }

                        results.add(addr);
                }

                return results;
        }
}
